<?php

/* (c) yoya@awm.jp */

require_once('FlashSWF/TagBlock.php');
require_once('BitStream.php');

class FlashSWF_TagBlock_DefineBitsJPEG extends FlashSWF_TagBlock {
        private $_jpegid;
	protected $_jpegdata;
	function __construct($tag, $length, $length_longformat, $rawdata) {
	        $length_longformat == TRUE;
                parent::__construct($tag, $length, $length_longformat, $rawdata);
		$bs = new BitStream($rawdata);
		$this->_jpegid = $bs->getBytesLE(2);
		$this->_jpegdata = $bs->getStrings();
		$jpegid = $this->_jpegid;
	}
	function getJpegID() {
	        return $this->_jpegid;
	}
	function getJpegData() {
	        return $this->_jpegdata;
	}
	function setJpegData($jpegdata) {
	        $this->_jpegdata = $jpegdata;
	}
	function getData() {
	  $bs = new BitStream();
	  $bs->putBytesLE($this->getJpegId(), 2);
	  return $bs->getData() . $this->getJpegData();
	}
	function save() {
	        $data = $this->getData();
		$length = strlen($data);
		$tag = $this->getTagId();
		$bs = new BitStream();
		// swf tag in long format
		$tag_and_length = ($tag << 6) | 0x3f;
		$bs->putBytesLE($tag_and_length, 2);
		$bs->putBytesLE($length, 4);
		return $bs->getData() . $this->getData();
	}
	function dump() {
	        parent::dump();
		$jpegid = $this->getJpegId();
		print "\tjpeg id=$jpegid\n";
	}
}
