<?php

/* (c) yoya@awm.jp */

// require_once('FlashSWF/TagBlock.php');
require_once('FlashSWF/TagBlock/DefineBitsJPEG.php');
require_once('BitStream.php');

class FlashSWF_TagBlock_DefineBitsJPEG3 extends FlashSWF_TagBlock_DefineBitsJPEG {
        private $_alpha;
	function __construct($tag, $length, $length_longformat, $rawdata) {
                parent::__construct($tag, $length, $length_longformat, $rawdata);
//		printf("jpegdata len=0x%x\n", strlen($this->getJpegData()));
		$bs = new BitStream($this->getJpegData());
		$offset_to_alpha = $bs->getBytesLE(4);
	//	printf("XXX 0x%x\n", $offset_to_alpha);
		$this->_jpegdata = $bs->getStrings($offset_to_alpha);
		//		$this->_alpha = $bs->getStrings();
		$gzalpha = $bs->getStrings();
		$buff_size = 32 * $offset_to_alpha; // XXX 32 : need tuning
		$this->_alpha = gzuncompress($gzalpha, $buff_size);
	//	printf("alpha len=0x%x\n", strlen($this->_alpha));
	}
	function getAlpha() {
	        return $this->_alpha;
	}
	function save() {
	        $data = $this->getData();
		$length = strlen($data);
		$tag = $this->getTagId();
		$bs = new BitStream();
		// swf tag in long format
		$tag_and_length = ($tag << 6) | 0x3f;
		$bs->putBytesLE($tag_and_length, 2);
		$bs->putBytesLE($length, 4);
		return $bs->getData() . $this->getData();
	}
	function dump() {
	        parent::dump();
		$jpegid = $this->getJpegId();
		$alpha = $this->getAlpha();
		$alpha_len = strlen($this->getAlpha());
		//		print "\tjpeg id=$jpegid alpha=$alpha\n";
		print "\tjpeg id=$jpegid alpha_len=$alpha_len\n";
	}
}
