<?php
  /* (c) yoya@awm.jp */
require_once('FlashSWF.php');
require_once('FlashJPEG.php');

if ($argc < 2) {
	fprintf(STDERR, "Usage: swfjpegextract <swf_file>\n");
	exit(1);
 }
$swf_filename = $argv[1];

$swf = new FlashSWF();
$swf->loadfile($swf_filename);
$block_list = &$swf->getBlockList();

$jpegtables = '';
foreach($block_list as &$block) {
	$tagid= $block->getTagId();
	// JPEGTables
	if ($tagid == 8) {
		$jpegtables = $block->getData();
	}
	// DefineBitsJPEG || DefineBitsJPEG3
	if (($tagid == 6)  || ($tagid == 35)) {
		$jpegid = $block->getJpegId();
		$jpegdata = $block->getJpegData();
		$jpegobj = new FlashJPEG($jpegdata);
		$jpegdata = $jpegobj->convertFromFlashJPEG($jpegtables);
		$jpegsize = strlen($jpegdata);
		$jpegfile = "image_$jpegid.jpg";
		printf("$jpegfile(len=$jpegsize)\n");
		file_put_contents($jpegfile, $jpegdata);
		if ($tagid == 35) { // DefineBitsJPEG3
		  $alphadata = $block->getAlpha();
		  $alphasize = strlen($alphadata);
		  $alphafile = "alpha_$jpegid.raw";
		  printf("$alphafile(len=$alphasize)\n");
		  file_put_contents($alphafile, $alphadata);
		}
	}
}
